#include <stdio.h>
#include <iostream>
#include "PARAM.h"
using std::cerr;
using std::cout;
using std::endl;

void PARAM::show_help() 
{
  cerr  <<"% "<<exec_name 
		<<" match-data \"eps-filename-template\"[options]\n"
		<<" input :  match-data\n"
		<<" output:  template1.eps template2.eps template_flow.eps\n"
	  
		<<"options -----\n"
		<<"-1             image1 input\n"
		<<"-2             image2 input\n"		
		<<"-C             make a circle arround every feature-points\n"
		<<"-D             make a dot on every feature-points\n"
		<<"-N [scale]     put the numbers. and set number-object scale \n"
		<<"-M             marking\n"
		<<"-W             flow EPS image width\n"
		<<"-H             flow EPS image height\n"
		<<"-l linewidth   set linewidth\n"
		<<"-s size        set figure scale size\n"
		<<"-u [u offset]  u offset of numbering\n"
		<<"-v [v offset]  v offset of numbering\n"
		<<"-q [quality]   jpeg quality\n"
		<<"-c [R,G,B]     output data color (default=0,0,0)\n"
		<<"-h             show this message\n"
		<<endl; 
  
} 
 
void PARAM::set_option(char option) 
{ 
  switch(option){ 
	case '1':
	  img_fn1  = new char[ strlen( optarg )   +1 ];
	  if(!img_fn1) exit(1);	  
	  strcpy(img_fn1,optarg);
	  break;
	  
	case '2':
	  img_fn2    = new char[ strlen( optarg )   +1 ];
	  if(!img_fn2) exit(1);	  
	  strcpy(img_fn2,optarg);
	  
	  break;
	  
	case 'C':
	  flag |= FLAG_CIRCLE;
	  break;
	case 'D':
	  flag |= FLAG_DOT;
	  break;
	case 'M':
	  flag |= FLAG_MARK;
	  break;
	case 'N':
	  flag |= FLAG_NUMBER;
	  sscanf(optarg,"%d",&number_scale);
	  break;
	  
	case 'W':
	  sscanf(optarg,"%d",&width);
	  break;
	case 'H':
	  sscanf(optarg,"%d",&height);
	  break;
	case 'l':
	  sscanf(optarg,"%d",&linewidth);
	  break;
	case 's':
	  sscanf(optarg,"%d",&figure_size);
	  break;
	case 'u':
	  sscanf(optarg,"%d",&offset_u);
	  break;
	case 'v':
	  sscanf(optarg,"%d",&offset_v);
	  break;
	case 'q':
	  sscanf(optarg,"%d",&jpg_quality);
	  break;
	case 'c':
	  sscanf(optarg,"%d,%d,%d",&col.r,&col.g,&col.b);
	  break;
	case 'h':
	  show_help();
	  exit(1);
	  break;
  
	default:
	  break;
  }
}


void PARAM::analysis_option(int argc, char *argv[])
{
  char option = -1;
  exec_name = new char [strlen(argv[0])+ 1];
  if(!exec_name){
	cerr << "can't get memory . exec name"<<endl;
	exit(1);
  }
  strcpy(exec_name, argv[0]);
  do{
    option = getopt(argc, argv, option_string);
    set_option(option);
  }while(option != -1);
  if( (argc - optind) < 2){
    show_help();
    exit(1);
  }
  
  match_fn     = new char[ strlen( argv[optind]  ) +1 ];
  view_name1   = new char[ strlen( argv[optind+1]) + 5 + 1];//"1.eps"ʸղ
  view_name2   = new char[ strlen( argv[optind+1]) + 5 + 1];//"2.eps"ʸղ
  flow_name    = new char[ strlen( argv[optind+1]) + 9 + 1];//"_flow.eps"ʸղ

  if(!match_fn|| !view_name1 || !view_name2 || !flow_name){
	cerr << "can't get memory"<<endl;
	exit(0);
  }
  strcpy(match_fn ,    argv[optind]);
  strcpy(view_name1,   argv[optind+1]);
  strcpy(view_name2,   argv[optind+1]);
  strcpy(flow_name,    argv[optind+1]);
  strcat(view_name1,   "1.eps");
  strcat(view_name2,   "2.eps");
  strcat(flow_name,    "_flow.eps"); 
  
}

