/************************************************
 ScreenPS.cc   Ver 1.0

             created by H.Kamo (2000/09/11) 
*************************************************/

#if __GNUC__ < 3
# include <stdio.h>
# include <ostream.h>
# include <fstream.h>
# include <string.h>
#else
# include <iostream>
# include <fstream>
# include <new>
using std::ofstream;
using std::cerr;
using std::endl;
#endif
#include "ScreenPS.h"

//
// static ؿΥץȥ
//
static void write_header(ofstream &fstr, int width, int height, int type);
static void write_prolog(ofstream &fstr);
static void write_footer(ofstream &fstr);


// ScreenPS::ScreenPS(char *fname, int xs, int ys, int type)
//   : ե̾, (), (⤵), PostScript 
//   : 󥹥ȥ饯
ScreenPS::ScreenPS(char *fname, int xs, int ys, PSType t)
{
  _type   = t;
  _width  = xs;
  _height = ys;
  _xc     = xs / 2;
  _yc     = ys / 2;

  // ե륪ץ
  if (fname) {
#if __GNUC__ < 3
    _filename = new char[strlen(fname)+1];
#else
    _filename = new(std::nothrow) char[strlen(fname)+1];
#endif
    if (_filename == 0) {
      cerr << "cannot allocate memories (ScreenPS)." << endl;
      exit(1);
    }
    strcpy(_filename, fname);
    _fstr.open(_filename);
    if (_fstr.fail()) {
      cerr << "cannot open stream (ScreenPS)." << endl;
      exit(1);
    }
  }
#if __GNUC__ < 3
  else {
    _fstr.attach(0);
  }
#else
  else {
    cerr << "must specify the function argument `fname' in ScreenPS::ScreenPS()" << endl;
    exit(1);
  }
#endif
  _open = 1;

  // إå
  write_header(_fstr, _width, _height, t);

  // ץ
  write_prolog(_fstr);
};


// ScreenPS::~ScreenPS()
//   : ʤ
//   : ǥȥ饯
ScreenPS::~ScreenPS()
{
  // 
  close();
};


// ScreenPS::close()
//   : ʤ
//   : 0 = , 1 = 
//   : եĤ
int ScreenPS::close()
{
  if (_open) {
    // եå
    write_footer(_fstr);

    // ե륯
    _fstr.close();
    if (_filename) {
      delete [] _filename;
    }
    _open = 0;
    return 1;
  }
  return 0;
};


// static void write_header(ofstream &fstr, int width, int height, int type)
//   : ե륹ȥ꡼, ڡ(), ڡ(⤵), PostScript 
//   : ʤ
//   : PostScript إå
static void write_header(ofstream &fstr, int width, int height, int type)
{
  if (type == PSF)
    fstr << "%!PS-Adobe-2.0" << endl;
  else
    fstr << "%!PS-Adobe-2.0 EPSF-2.0" << endl;
  fstr << "%%Creator: ScreenPS" << endl;
  fstr << "%%Title: ScreenPS output" << endl;
  fstr << "%%Pages: 1" << endl;
#if __GNUC__ < 3
  fstr << form("%%%%BoundingBox: 0 0 %d %d", width, height) << endl;
#else
  fstr << "%%BoundingBox: 0 0 " << width << " " << height << endl;
#endif
  fstr << "%%EndComments" << endl;
}


// static void write_prolog(ofstream &fstr)
//   : ե륹ȥ꡼
//   : ʤ
//   : PostScript ץ
static void write_prolog(ofstream &fstr)
{
  fstr << "%%EndProlog" << endl;
  fstr << "%%Page: 1 1" << endl;
}


// static void write_footer(ofstream &fstr)
//   : ե륹ȥ꡼
//   : ʤ
//   : PostScript եå
static void write_footer(ofstream &fstr)
{
  fstr << "showpage" << endl;
  fstr << "%%Trailer" << endl;  
}
